--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   16:27:18 01/11/2013
-- Design Name:   
-- Module Name:   /home/cwoodall/Documents/Projects/CMS_gadget/firmware/phase2/Phase2/ipbus_dpram32x8b_TST.vhd
-- Project Name:  Phase2
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: ipbus_dist_ram32x32
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
use work.ipbus.all;
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY ipbus_dpram32x8b_TST IS
END ipbus_dpram32x8b_TST;
 
ARCHITECTURE behavior OF ipbus_dpram32x8b_TST IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT ipbus_dist_ram32x32
    PORT(
         clk : IN  std_logic;
         reset : IN  std_logic;
         ipbus_in : in ipb_wbus;
         ipbus_out : OUT  ipb_rbus;
         oob_strobe : IN  std_logic;
         oob_addr : IN  std_logic_vector(7 downto 0);
         oob_write : IN  std_logic;
         oob_ack : OUT  std_logic;
         oob_wdata : IN  std_logic_vector(31 downto 0);
         oob_rdata : IN  std_logic_vector(31 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal reset : std_logic := '0';
   signal ipbus_in : ipb_wbus;
   signal oob_strobe : std_logic := '0';
   signal oob_addr : std_logic_vector(7 downto 0) := (others => '0');
   signal oob_write : std_logic := '0';
   signal oob_wdata : std_logic_vector(31 downto 0) := (others => '0');
   signal oob_rdata : std_logic_vector(31 downto 0) := (others => '0');

 	--Outputs
   signal ipbus_out : ipb_rbus;
   signal oob_ack : std_logic;

   -- Clock period definitions
   constant clk_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: ipbus_dist_ram32x32 PORT MAP (
          clk => clk,
          reset => reset,
          ipbus_in => ipbus_in,
          ipbus_out => ipbus_out,
          oob_strobe => oob_strobe,
          oob_addr => oob_addr,
          oob_write => oob_write,
          oob_ack => oob_ack,
          oob_wdata => oob_wdata,
          oob_rdata => oob_rdata
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	

      wait for clk_period*10;
      wait for clk_period;
      wait for clk_period;
      ipbus_in.ipb_addr <= x"00000000";
      ipbus_in.ipb_wdata <= x"DEADBEEF";
      ipbus_in.ipb_strobe<='1';
      ipbus_in.ipb_write<='1';
      wait for clk_period;
      ipbus_in.ipb_strobe<='0';
      ipbus_in.ipb_write<='0';
      wait for clk_period;
      ipbus_in.ipb_addr <= x"00000001";
      ipbus_in.ipb_wdata <= x"DEADBEEF";
      ipbus_in.ipb_strobe<='1';
      ipbus_in.ipb_write<='1';
      wait for clk_period;
      ipbus_in.ipb_strobe<='0';
      ipbus_in.ipb_write<='0';
      wait for clk_period*10;
      ipbus_in.ipb_addr <= x"00000002";
      ipbus_in.ipb_wdata <= x"FF00FF00";
      ipbus_in.ipb_strobe<='1';
      ipbus_in.ipb_write<='1';
      wait for clk_period;
      ipbus_in.ipb_strobe<='0';
      ipbus_in.ipb_write<='0';
      wait for clk_period*10;
      ipbus_in.ipb_addr <= x"00000001";
      ipbus_in.ipb_wdata <= x"FF00FF00";
      ipbus_in.ipb_strobe<='1';
      ipbus_in.ipb_write<='0';
      wait for clk_period;
      ipbus_in.ipb_strobe<='0';
      -- insert stimulus here 

      wait;
   end process;

END;
