--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   10:32:57 11/05/2012
-- Design Name:   
-- Module Name:   /home/cwoodall/Documents/Projects/CMS_gadget/firmware/testing/Ethernet/src/IPbusFirmware/example_designs/ise_projects/ipbus_demo_sp601/ethernet_mac_tst.vhd
-- Project Name:  ipbus_demo_sp601
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: ethernet_mac
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY ethernet_mac_tst IS
END ethernet_mac_tst;
 
ARCHITECTURE behavior OF ethernet_mac_tst IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT ethernet_mac
    PORT(
         rxd : IN  std_logic_vector(3 downto 0);
         rxdv : IN  std_logic;
         rxclk : IN  std_logic;
         rxer : IN  std_logic;
         txd : OUT  std_logic_vector(3 downto 0);
         txen : OUT  std_logic;
         txer : OUT  std_logic;
         txclk : IN  std_logic;
         crs : IN  std_logic;
         col : IN  std_logic;
         mdio : INOUT  std_logic;
         mdc : OUT  std_logic;
         rx_mac_data : OUT  std_logic_vector(7 downto 0);
         rx_mac_clk : OUT  std_logic;
         rx_mac_valid : OUT  std_logic;
--         rx_mac_fcs : OUT  std_logic_vector(31 downto 0);
--         rx_mac_crc : OUT  std_logic_vector(31 downto 0);
         rx_mac_goodframe : OUT  std_logic;
         rx_mac_badframe : OUT  std_logic;
         tx_mac_clk : OUT  std_logic;
         tx_mac_valid : IN  std_logic;
         tx_mac_ack : OUT  std_logic;
         tx_mac_data : IN  std_logic_vector(7 downto 0);
         rst_n : IN  std_logic;
         enable_n : IN  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal rxd : std_logic_vector(3 downto 0) := (others => '0');
   signal rxdv : std_logic := '0';
   signal rxclk : std_logic := '0';
   signal rxer : std_logic := '0';
   signal txclk : std_logic := '0';
   signal crs : std_logic := '0';
   signal col : std_logic := '0';
   signal tx_mac_valid : std_logic := '0';
   signal tx_mac_data : std_logic_vector(7 downto 0) := (others => '0');
   signal rst_n : std_logic := '0';
   signal enable_n : std_logic := '0';

	--BiDirs
   signal mdio : std_logic;

 	--Outputs
   signal txd : std_logic_vector(3 downto 0);
   signal txen : std_logic;
   signal txer : std_logic;
   signal mdc : std_logic;
   signal rx_mac_data : std_logic_vector(7 downto 0);
   signal rx_mac_clk : std_logic;
   signal rx_mac_valid : std_logic;
--   signal rx_mac_fcs : std_logic_vector(31 downto 0);
--   signal rx_mac_crc : std_logic_vector(31 downto 0);
   signal rx_mac_goodframe : std_logic;
   signal rx_mac_badframe : std_logic;
   signal tx_mac_clk : std_logic;
   signal tx_mac_ack : std_logic;

   -- Clock period definitions
   constant rxclk_period : time := 10 ns;
   constant txclk_period : time := 10 ns;
   constant rx_mac_clk_period : time := 10 ns;
   constant tx_mac_clk_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: ethernet_mac PORT MAP (
          rxd => rxd,
          rxdv => rxdv,
          rxclk => rxclk,
          rxer => rxer,
          txd => txd,
          txen => txen,
          txer => txer,
          txclk => txclk,
          crs => crs,
          col => col,
          mdio => mdio,
          mdc => mdc,
          rx_mac_data => rx_mac_data,
          rx_mac_clk => rx_mac_clk,
          rx_mac_valid => rx_mac_valid,
--          rx_mac_fcs => rx_mac_fcs,
--          rx_mac_crc => rx_mac_crc,
          rx_mac_goodframe => rx_mac_goodframe,
          rx_mac_badframe => rx_mac_badframe,
          tx_mac_clk => tx_mac_clk,
          tx_mac_valid => tx_mac_valid,
          tx_mac_ack => tx_mac_ack,
          tx_mac_data => tx_mac_data,
          rst_n => rst_n,
          enable_n => enable_n
        );

   -- Clock process definitions
   rxclk_process :process
   begin
		rxclk <= '0';
		wait for rxclk_period/2;
		rxclk <= '1';
		wait for rxclk_period/2;
   end process;
 
   txclk_process :process
   begin
		txclk <= '0';
		wait for txclk_period/2;
		txclk <= '1';
		wait for txclk_period/2;
   end process;
 
   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	

      wait for rxclk_period*10;
      rxdv <= '1';
      rst_n <= '1';
      rxer <= '0';
      rxd <= x"A";
      wait for rxclk_period;
      rxd <= x"B";
      wait for rxclk_period;
      rxd <= x"C";
      wait for rxclk_period;
      rxdv <= '0';
      -- insert stimulus here 

      wait;
   end process;

END;
